//! `SeaORM` Entity. Generated by sea-orm-codegen 0.11.3

use super::sea_orm_active_enums::Method;
use crate::serialization;
use sea_orm::entity::prelude::*;
use serde::{Deserialize, Serialize};

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq, Serialize, Deserialize)]
#[sea_orm(table_name = "revert_log")]
pub struct Model {
    #[sea_orm(primary_key)]
    pub id: u64,
    pub rpc_key_id: u64,
    pub timestamp: DateTimeUtc,
    pub method: Method,
    #[sea_orm(column_type = "Binary(BlobSize::Blob(Some(20)))")]
    #[serde(
        serialize_with = "serialization::vec_as_address",
        deserialize_with = "serialization::address_to_vec"
    )]
    pub to: Vec<u8>,
    #[sea_orm(column_type = "Text", nullable)]
    pub call_data: Option<String>,
    pub chain_id: u64,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(
        belongs_to = "super::rpc_key::Entity",
        from = "Column::RpcKeyId",
        to = "super::rpc_key::Column::Id",
        on_update = "NoAction",
        on_delete = "NoAction"
    )]
    RpcKey,
}

impl Related<super::rpc_key::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::RpcKey.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
