//! `SeaORM` Entity. Generated by sea-orm-codegen 0.11.3

use sea_orm::entity::prelude::*;
use serde::{Deserialize, Serialize};

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Serialize, Deserialize)]
#[sea_orm(table_name = "rpc_accounting")]
pub struct Model {
    #[sea_orm(primary_key)]
    pub id: u64,
    pub rpc_key_id: Option<u64>,
    pub chain_id: u64,
    pub method: Option<String>,
    pub error_response: bool,
    pub period_datetime: DateTimeUtc,
    pub frontend_requests: u64,
    pub backend_requests: u64,
    pub cache_misses: u64,
    pub cache_hits: u64,
    pub sum_request_bytes: u64,
    pub min_request_bytes: u64,
    #[sea_orm(column_type = "Double")]
    pub mean_request_bytes: f64,
    pub p50_request_bytes: u64,
    pub p90_request_bytes: u64,
    pub p99_request_bytes: u64,
    pub max_request_bytes: u64,
    pub sum_response_millis: u64,
    pub min_response_millis: u64,
    #[sea_orm(column_type = "Double")]
    pub mean_response_millis: f64,
    pub p50_response_millis: u64,
    pub p90_response_millis: u64,
    pub p99_response_millis: u64,
    pub max_response_millis: u64,
    pub sum_response_bytes: u64,
    pub min_response_bytes: u64,
    #[sea_orm(column_type = "Double")]
    pub mean_response_bytes: f64,
    pub p50_response_bytes: u64,
    pub p90_response_bytes: u64,
    pub p99_response_bytes: u64,
    pub max_response_bytes: u64,
    pub archive_request: bool,
    pub origin: Option<String>,
    pub migrated: Option<DateTimeUtc>,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(
        belongs_to = "super::rpc_key::Entity",
        from = "Column::RpcKeyId",
        to = "super::rpc_key::Column::Id",
        on_update = "NoAction",
        on_delete = "NoAction"
    )]
    RpcKey,
}

impl Related<super::rpc_key::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::RpcKey.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
